#ifndef MOG2_ANIM_SCRIPTS
#define MOG2_ANIM_SCRIPTS

#define ANIM_CMD_NONE		0
#define ANIM_CMD_SINGLE		1
#define ANIM_CMD_SEQ		2
#define ANIM_CMD_LOOP		3
#define ANIM_CMD_GSEQ		4
#define ANIM_CMD_GLOOP		5

#define ANIM_MAX_CMD		6

#define ANIM_NOBITMAP		-1
#define ANIM_INVALID		-2


class AnimFRAME {
public:
	int frame;
	int p_offset_p;
	int p_offset_o;
	SAMPLE *sample;
	int sample_volume;
};

class AnimSCRIPT {
	friend class BViewAnimScriptWnd;
	friend class ActiveOBJECT;

public:
	AnimSCRIPT(void);
	AnimSCRIPT(AnimSCRIPT &s);
	~AnimSCRIPT(void);

	bool load(FILE *fp,class MOG2 *game);
	bool save(FILE *fp);

	char *generate_string(void);

	void init(void);
	bool cycle(void);
	int get_tile(void);
	int get_p_offset_p(void);
	int get_p_offset_o(void);
	SAMPLE *get_sample(void);
	int get_sample_volume(void);

	void copy_state(AnimSCRIPT *s);

private:

	int tile,lastvalidtile;
	int p_offset_p;
	int p_offset_o;
	SAMPLE *sample;
	int sample_volume;
	int timmer;

	int command;
	int ipar;
	AnimFRAME fpar;
	List<AnimFRAME> fparlist;
	List<AnimSCRIPT> aparlist;
};


#endif

